%define kmodname flashcache
# What kernel are we building for?
%{!?kernel: %define kernel %(uname -r)}
# Get the correct kernel package release by stripping kernel modifiers
%define krel %(echo %{kernel} | sed -r 's/\.(x86_64|i686)//g')
%define kversion %(echo %{krel})
%define kernel_moduledir /lib/modules/%{kversion}.%{_target_cpu}


Summary: A write-back block cache for Linux
Name: flashcache
Vendor: flashcache development, https://github.com/percona/flashcache
Version: 2
Release: 20130523095210.git81e55a3%{?dist}
License: GPL
Group: System Environment/Base
URL: https://github.com/facebook/flashcache/
Source0: %{name}-%{version}.tar.gz
Requires(post): /sbin/chkconfig
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: tar gcc make kernel-devel rpm-build
ExclusiveArch: x86_64

%description
Flashcache : A write-back block cache for Linux

#http://rpmfusion.org/Packaging/KernelModules/Kmods2
%package       -n kmod-%{kmodname}-%{kversion}.%{_target_cpu}
Summary:          %{kmodname} kernel module(s) for %{kversion}
Group:            System Environment/Kernel
Provides:         kernel-modules-for-kernel = %{kversion}
Provides:         %{kmodname}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires(post):   /sbin/depmod
Requires(postun): /sbin/depmod
Requires:         kernel-%{_target_cpu} = %{kversion}
BuildRequires:    kernel
BuildRequires:    kernel-devel

%description  -n kmod-%{kmodname}-%{kversion}.%{_target_cpu}
This package provides the %{kmodname} kernel modules built for the Linux

%prep
%setup -q

%build
cd src/
make KERNEL_TREE=%{kernel_moduledir}/source/
#cd ../flashcache-wt/src/
#make KERNEL_TREE=%{kernel_moduledir}/source/

%install
install -o root -g root -m 0755 -d %{buildroot}/%{kernel_moduledir}/extra/flashcache
install -o root -g root -m 0755 src/flashcache.ko %{buildroot}/%{kernel_moduledir}/extra/flashcache/
#install -o root -g root -m 0755 flashcache-wt/src/flashcache-wt.ko %{buildroot}/%{kernel_moduledir}/extra/flashcache/
install -o root -g root -m 0755 -d %{buildroot}/sbin
install -o root -g root -m 0755 src/utils/flashcache_create %{buildroot}/sbin/
install -o root -g root -m 0755 src/utils/flashcache_destroy %{buildroot}/sbin/
install -o root -g root -m 0755 src/utils/flashcache_load %{buildroot}/sbin/
#install -o root -g root -m 0755 flashcache-wt/src/utils/flashcache_wt_create %{buildroot}/sbin/
install -o root -g root -m 0755 -d %{buildroot}/%{_sysconfdir}/rc.d/init.d
install -o root -g root -m 0755 -d %{buildroot}/%{_sysconfdir}/sysconfig
install -o root -g root -m 0755 src/sysvinit/flashcache %{buildroot}/%{_sysconfdir}/rc.d/init.d/flashcache
install -o root -g root -m 0644 src/sysconfig/flashcache %{buildroot}/%{_sysconfdir}/sysconfig/flashcache
install -o root -g root -m 0644 README %{buildroot}/sbin/
install -o root -g root -m 0755 -d %{buildroot}/usr/share/doc/%{name}-%{version}
install -o root -g root -m 0644 doc/flashcache-doc.txt %{buildroot}/usr/share/doc/%{name}-%{version}/
install -o root -g root -m 0644 doc/flashcache-sa-guide.txt %{buildroot}/usr/share/doc/%{name}-%{version}/

%clean
rm -rf %{buildroot}

%files
/sbin/*
/usr/share/doc/%{name}-%{version}/*
%{_sysconfdir}/rc.d/init.d/flashcache
%config(noreplace) %{_sysconfdir}/sysconfig/flashcache

%files -n kmod-%{name}-%{kversion}.%{_target_cpu}
%{kernel_moduledir}/extra/flashcache/*

%post
chkconfig --add flashcache


%post          -n kmod-%{kmodname}-%{kversion}.%{_target_cpu}
/sbin/depmod -aeF /boot/System.map-%{kversion}.%{_target_cpu} %{kversion}.%{_target_cpu} > /dev/null || :

%postun        -n kmod-%{kmodname}-%{kversion}.%{_target_cpu}
/sbin/depmod  -aF /boot/System.map-%{kversion}.%{_target_cpu} %{kversion}.%{_target_cpu} &> /dev/null || :

%changelog

* Thu Feb 03 2011 13:00:00 +09:00 Hajime Taira <htaira@redhat.com>
- Split RPM package: flashcache and kmod-flashcache-<uname -r>

* Sun Dec 05 2010 13:00:00 +09:00 Hajime Taira <htaira@redhat.com>
- Initial build.

2013-04-02  David Busby <oneiroi@fedoraproject.org>

	* src/sysvinit/flashcache: removal of optional dmsetup remove,
	currently non optional as breaks ability to stop/start while os
	online

2013-04-02  David Busby <oneiroi@fedoraproject.org>

	* src/sysconfig/flashcache, src/sysvinit/flashcache: Added switch to
	enable/disable dmsetup remove on stop() call via DIRTYSYNC_ONSTOP in
	sysconfig file

2013-04-02  David Busby <oneiroi@fedoraproject.org>

	* src/sysvinit/flashcache: -eq changed to ==

2013-04-02  David Busby <oneiroi@fedoraproject.org>

	* src/sysvinit/flashcache: sysvinit script fixes allow for startup
	of service post reboot, works with mysql in vm at least

2013-04-02  David Busby <oneiroi@fedoraproject.org>

	* Makefile: Errant whitespace leading to dist-test failiure

2013-03-15  David Busby <oneiroi@fedoraproject.org>

	* src/sysvinit/flashcache: typo correction

2013-03-12  David Busby <oneiroi@fedoraproject.org>

	* Makefile, src/sysvinit/flashcache: Release 2 in makefile, updated
	sysvinit script to use flashcache_load on write-back only uses
	flashcache_create for all others

2013-03-07  David Busby <oneiroi@fedoraproject.org>

	* src/sysvinit/flashcache: noatime,nobarrier not adding nodiratime
	as this is implied by noatime

2013-03-06  David Busby <oneiroi@fedoraproject.org>

	* src/sysvinit/flashcache: Make the sysctl reload quiet

2013-03-06  David Busby <oneiroi@fedoraproject.org>

	* src/sysvinit/flashcache: typo fix in stop was causing dmsetup
	remove to fail in sysvinit

2013-03-06  David Busby <oneiroi@fedoraproject.org>

	* Makefile: dist-test new buiulds failing to upgrade existing
	installs ...

2013-03-06  David Busby <oneiroi@fedoraproject.org>

	* Makefile: Cleanup post sysvinit rework

2013-03-06  David Busby <oneiroi@fedoraproject.org>

	* src/sysvinit/flashcache: Ok single device support should now be
	functional

2013-03-06  David Busby <oneiroi@fedoraproject.org>

	* flashcache.spec.in: Removed the patching requirements we're just
	retaining original fil now

2013-03-06  David Busby <oneiroi@fedoraproject.org>

	* flashcache-sysvinit.patch: Makes no sense to retain this patch now

2013-03-06  David Busby <oneiroi@fedoraproject.org>

	* flashcache-wt/Makefile, flashcache-wt/README,
	flashcache-wt/src/Makefile, flashcache-wt/src/dkms.conf,
	flashcache-wt/src/flashcache_wt.c,
	flashcache-wt/src/flashcache_wt.h,
	flashcache-wt/src/utils/flashcache_wt_create.c: flashcache-wt is
	deperecated, and not in use in these build removing the source for
	clarity see moahs comment here:
	https://github.com/facebook/flashcache/issues/68

2013-03-06  David Busby <oneiroi@fedoraproject.org>

	* src/sysconfig/flashcache: Yes it's a single cache setup, will add
	multiple after making singlular functional

2013-03-06  David Busby <oneiroi@fedoraproject.org>

	* src/sysvinit/flashcache: Reworking this first to make it easier
	use second _wt is deperecated and no longer in use, third argv order
	and count has changed for flashcache_load

2013-02-21  David Busby <oneiroi@fedoraproject.org>

	* flashcache.spec.in: Fixed issues where depmod would fail
	postinstall

2013-02-21  David Busby <oneiroi@fedoraproject.org>

	* flashcache.spec.in: had to rework tieing to a kernel version, rand
	ito issues cinstalling kmod

2013-02-18  David Busby <oneiroi@fedoraproject.org>

	* Makefile: Reincluding date into dist-test output

2013-02-18  David Busby <oneiroi@fedoraproject.org>

	* Makefile, flashcache.spec.in: Makefile stirps data from
	git_release, let us just use the githash, .spec.in file updated
	creates own kversion variable which is replaced via the Makefile
	during .spec genration reffer to the Makefile for specific kernel
	targeting where required

2013-02-18  David Busby <oneiroi@fedoraproject.org>

	* Makefile, flashcache.spec.in: .spec.in file uses @KERNEL_TARGET@
	marker replaced by Makefile run, defaults to uname -r

2013-02-18  David Busby <oneiroi@fedoraproject.org>

	* Makefile: Reprioritize cleanup such that rpm files removed first
	in clean

2013-02-18  David Busby <oneiroi@fedoraproject.org>

	* flashcache.spec.in: flashcache_wt is deprecated per command from
	mohans here:
	https://github.com/facebook/flashcache/pull/98#issuecomment-11102066
	removing build of flashcache_wt as also contains broken code

2013-02-15  David Busby <oneiroi@fedoraproject.org>

	* README-3.x-KERNEL: Removing 3.x readme as information is
	missleading stable_v2 branch compiles fine this head, is the issue
	with bad code.

2013-02-15  David Busby <oneiroi@fedoraproject.org>

	* flashcache.spec.in: Having to hard code kernel for mock to work,
	as uname -r is reporting the host kernel not the mock chroot ...
	currently failing at -bb due to same issues as in 3.x kernel readme

2013-02-15  David Busby <oneiroi@fedoraproject.org>

	* flashcache.spec.in: Package requirements now working, well at
	least it installs the requirements and heads onto the build phase in
	mock now

2013-02-15  David Busby <oneiroi@fedoraproject.org>

	* Makefile: split into rpmsource method

2013-02-15  David Busby <oneiroi@fedoraproject.org>

	* README-3.x-KERNEL: Added readme with notes w.r.t. 3.x Kernel

2013-02-15  David Busby <oneiroi@fedoraproject.org>

	* Makefile, flashcache-sysvinit.patch: Mostly working dist-test
	build now, pulled in sysvinit patch from RH 2011 packages

2013-02-15  David Busby <oneiroi@fedoraproject.org>

	* Makefile, flashcache.spec, flashcache.spec.in: Work on converting
	static spec file to allow for CI builds, now .spec.in file, also
	uses git2cl to populate change log

2013-02-15  David Busby <oneiroi@fedoraproject.org>

	* flashcache.spec: Pulling in .spec from
	http://htaira.fedorapeople.org/flashcache/flashcache.spec to use as
	starting point

2013-02-10  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #107 from Zedzap/master Fix use-after-free in flashcache_destroy

2012-11-14  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #93 from leseb/patch-1 Fixed the /proc path of flashcache_version

2012-10-09  Mohan Srinivasan <mohan@fb.com>

	* src/flashcache.h, src/flashcache_conf.c: Change to make flashcache
	compile on 3.6.0.  Summary: Changes to make flashcache compile on 3.6.0. Thanks to
	Thomas Stein for quickly verifying that the patch works.  Test Plan: Reviewers: CC: Task ID: # Blame Rev:

2012-11-03  Mohan Srinivasan <mohan@fb.com>

	* src/flashcache_main.c: If the SSD is dead, bypass *all* IOs to
	disk in the writerthrough and writearound modes.  Patch submitted by
	Arne Wiebalck.  Summary: Test Plan: Reviewers: CC: Task ID: # Blame Rev:

2012-11-03  Mohan Srinivasan <mohan@fb.com>

	* src/flashcache_conf.c, src/flashcache_main.c: Disambiguate ssd
	errors and disk errors on IO completion. On IO completion for the
	!WRITEBACK case, issue an uncached disk IO in the case of a SSD
	error.  Patch submitted by Mohit Saxena.  Summary: Test Plan: Reviewers: CC: Task ID: # Blame Rev:

2012-10-25  Mohan Srinivasan <mohan@fb.com>

	* src/flashcache.h, src/flashcache_conf.c: Fix a bug in
	flashcache_writeback_load(), where a bad argument is being passed
	into vmalloc().  Summary: The vmalloc() for the superblock in
	flashcache_writeback_load() is passed a bad size argument. Thanks to
	Ping Huang for spotting this and reporting it.  Test Plan: Reviewers: CC: Task ID: # Blame Rev:

2012-10-25  Mohan Srinivasan <mohan@fb.com>

	* src/flashcache_main.c: Bump flashcache sw revision in stable_v2 to
	2.0.  Summary: Bump flashcache sw revision in stable_v2 to 2.0.  Test Plan: Reviewers: CC: Task ID: # Blame Rev:

2012-08-24  Mohan Srinivasan <mohan@fb.com>

	* src/flashcache.h, src/flashcache_ioctl.c, src/flashcache_main.c: 
	In WriteThru and WriteAround modes, fall back to disk on SSD errors.  Summary: Committing an old patch to handle SSD errors in writethru
	and writearound modes to fall back to disk instead of returning
	errors back to the user. This path needs to be extended for
	writeback as well (failed reads on a !DIRTY block and failed new
	writes can be similarly handled. Thanks to Arne Wiebalck for
	providing the impetus for this change, reworking my initial attempt
	and testing the patch in production.  Test Plan: Reviewers: CC: Task ID: # Blame Rev:

2012-10-10  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #88 from critdamage/patch-1 Update utils/flashcache

2012-09-24  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #83 from boopathi/master Utility to load and unload flashcache

2012-09-22  Boopathi Rajaa <me@boopathi.in>

	* utils/flashcache: added forcestop feature

2012-09-22  Boopathi Rajaa <me@boopathi.in>

	* utils/flashcache: included few globals :P

2012-09-22  Boopathi Rajaa <me@boopathi.in>

	* utils/flashcache: fixed bug - should use double quotes with -n in
	bash

2012-09-22  Boopathi Rajaa <me@boopathi.in>

	* utils/flashcache: Flashcache init script - basic

2012-09-22  Boopathi Rajaa <me@boopathi.in>

	* utils/flashcache: Added flashcache sysVinitscript - empty

2012-08-23  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #77 from codyro/master Added basic checking for OpenVZ platforms

2012-08-22  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #76 from Youscribe/dkms_version add ability to set version into dkms Makfile

2012-07-21  Mohan Srinivasan <mohan@fb.com>

	* doc/flashcache-sa-guide.txt: Adding a note about cache
	utilization.  Summary: Note about cache utilization added to SA guide. Contributed
	by Will Smith.  Test Plan: Reviewers: CC: Task ID: # Blame Rev:

2012-07-20  Mohan Srinivasan <mohan@fb.com>

	* src/utils/Makefile, src/utils/get_agsize.c: Committing
	get_agsize.c utility.  Summary: get_agsize computes the optimal agcount/agsize for an
	XFS/flashcache volume. Written by Kumar Sundararajan (facebook).  Test Plan: Reviewers: CC: Task ID: # Blame Rev:

2012-07-09  Mohan Srinivasan <mohan@fb.com>

	* src/flashcache_main.c: Fix for a crash for the (fallow_cleaning &&
	LRU_reclaim) case.  Summary: Fix for a copy-paste bug, which can cause crashes when
	fallow cleaning is enabled in conjunction with LRU reclamation.
	Found by Vyacheslav Maslow and Wang Ning. This bug was also fixed a
	long time ago (but not committed) by Kumar Sundararajan (facebook).  Test Plan: Reviewers: CC: Task ID: # Blame Rev:

2012-06-12  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #70 from Youscribe/flashstat-basename flashstat don't work with names

2012-04-30  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #65 from b1-systems/master fix on SusE

2012-04-10  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #63 from dvance/master Fix to the flashcache OCF resource agent.

2012-04-06  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #62 from lastguru1/upstream Fixing: typo and forgotten if

2012-04-03  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #61 from lastguru1/upstream Tool to set whitelist/blacklist ioctl

2012-04-04  Dmitry Golubev <lastguru@gmail.com>

	* src/utils/flashcache_setioctl.c: Added flashcache_setioctl tool to
	manage blacklists and whitelists

2012-03-23  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #60 from NinGoo/master bugfix for flashstat line 255 regexp

2012-03-03  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #57 from PreetamJinka/patch-1 Incorrect command names

2012-02-17  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #52 from onlyjob/master man pages

2012-01-25  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #11 from fghaas/ocf-ra An Open Cluster Framework (OCF) compliant resource agent for
	flashcache

2012-01-11  NinGoo <haiyuan.ning@gmail.com>

	* utils/flashstat: add utils flashstat for status monitor per second

2012-01-06  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #47 from snajpa/master Fix RHEL6 compile error properly

2012-01-07  Pavel Snajdr <psnajdr@redhat.com>

	* src/flashcache_conf.c: Fix RHEL6 compile error properly

2011-12-28  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #45 from crossroads/master Fix to allow FlashCache to compile on CentOS 6

2011-10-26  Mohan Srinivasan <mohan@devrs301.snc6.facebook.com>

	* : commit c58e018994a215a2971d95e414a4912fa145ae42 Merge: 5fadabd
	98ace3f Author: Mohan Srinivasan <mohan_srinivasan@yahoo.com> Date:
	Wed Oct 26 18:11:11 2011 -0700

2011-10-26  Will <will@willsmith.org>

	* doc/flashcache-sa-guide.txt: Point bugs / issues to the github
	issue list.  Mention loopback device explicitly.

2011-10-25  Mohan Srinivasan <mohan@devrs301.snc6.facebook.com>

	* src/flashcache_conf.c: Improve error reporting from the flashcache
	create/load paths to indicate whether the underlying device is busy
	(might be mounted elsewhere).  Thanks to JohnW for the fix.

2011-10-25  Will <will@willsmith.org>

	* src/flashcache_procfs.c: forgot to expose "skip_seq_thresh_kb"
	sysctl in writethrough mode

2011-10-25  Will <will@willsmith.org>

	* src/flashcache_conf.c, src/flashcache_main.c,
	src/flashcache_subr.c: merge identical code down 2 execution or
	compilation paths

2011-10-18  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #35 from willsmithorg/master flashcache_create : warn of core memory overhead, ask confirmation
	if >25% of RAM

2011-10-19  Will Smith <will@willsmith.org>

	* doc/flashcache-doc.txt, src/flashcache_conf.c: minor : fix error
	in doc (mirroring is RAID1 not RAID0) and tidy up a dmemit.

2011-10-17  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #34 from willsmithorg/master Skip sequential IO

2011-10-16  Will Smith <will@willsmith.org>

	* src/flashcache_ioctl.c: Remove overly noisy linked list dump
	DPRINTKs.

2011-10-16  Will Smith <will@willsmith.org>

	* doc/flashcache-doc.txt, doc/flashcache-sa-guide.txt,
	flashcache-wt/README, src/flashcache.h, src/flashcache_conf.c,
	src/flashcache_ioctl.c, src/flashcache_ioctl.h,
	src/flashcache_main.c, src/flashcache_procfs.c: Skip sequential IO
	(optional, defaults to off, sysctl'able).

2011-10-08  Mohan Srinivasan <mohan@devrs301.snc6.facebook.com>

	* src/utils/flashcache_create.c: Add a missing break for the
	terabyte cache case in the previous commit. (Thanks to Will Smith
	for the fix).

2011-10-08  Mohan Srinivasan <mohan@devrs301.snc6.facebook.com>

	* src/utils/flashcache_create.c: Committing 2 (cmdline) fixes from
	Will Smith. For some reason GitHub won't allow me to auto-merge
	this.  1) thru == through (cache mode).  2) m == M, g == G, t == T.

2011-10-07  Mohan Srinivasan <mohan@devrs301.snc6.facebook.com>

	* src/flashcache_conf.c: Reverting the recent change that removed
	msleep() from the fast remove path.  After I merged that change, I
	saw that this msleep() was masking (effectively working around) a
	race between fast remove and clean_set(). Introducing the msleep()
	for now, until we fix that race.

2011-10-05  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #30 from ishibashi/master Shortening of  execution time of fast_remove

2011-10-03  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #29 from ishibashi/master Fixed abort the write-back of fast_remove

2011-09-23  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #26 from
	guppy/892908afdf319c514392e17525c923a8c90687f4 Missing cast

2011-09-22  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #25 from willsmithorg/master Removed lots of duplicated lines in #ifdef blocks in
	flashcache_conf.c and flashcache_procfs.c

2011-09-21  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #24 from unit3/master Updated CentOS/RHEL5 building

2011-09-20  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #23 from willsmithorg/master Updated -sa- documentation.

2011-09-19  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #22 from onlyjob/patch-2 Respect $(DESTDIR) in order to comply with GNU Make best practice.

2011-09-20  onlyjob <onlyjob@member.fsf.org>

	* src/Makefile: Respect $(DESTDIR) in order to comply with GNU Make
	best practice.

2011-09-20  onlyjob <onlyjob@member.fsf.org>

	* src/utils/Makefile: Respect $(DESTDIR)in order to comply with GNU
	Make best practice.

2011-09-19  Mohan Srinivasan <mohan_srinivasan@yahoo.com>

	* : Merge pull request #20 from unit3/master Pull in DKMS/autoload/initramfs support.

2011-09-19  Graeme Humphries <graeme@demonware.net>

	* doc/flashcache-sa-guide.txt: Updated doc for flashcache_load to
	discuss optional cachedev parameter.

2011-09-20  Will <will@willsmith.org>

	* src/flashcache.h, src/flashcache_procfs.c: Those sysctls with
	limits : enforce nicely.

2011-09-13  Graeme Humphries <graeme@demonware.net>

	* src/flashcache.h, src/utils/flashcache_load.c: Minor update per
	Mohan to check for previous v2 superblock data and store virtual
	device name.

2011-09-13  Graeme Humphries <graeme@demonware.net>

	* src/flashcache.h: Reverting superblock version to "2" per Mohan,
	as there's no changes to the data layout.

2011-09-09  Graeme Humphries <graeme@demonware.net>

	* Makefile.dkms, README-DKMS, doc/flashcache-sa-guide.txt,
	src/dkms.conf, src/flashcache.h, src/flashcache.hook,
	src/flashcache_conf.c, src/utils/flashcache_create.c,
	src/utils/flashcache_load.c, src/utils/flashcache_scan: Changes to
	enhance DKMS support, initramfs boot support, and scanning /
	autoloading of flashcache devices.

2011-09-09  Graeme Humphries <graeme@demonware.net>

	* : Merge remote-tracking branch 'upstream/master'

2011-08-09  Rohan Puri <rohan.puri15@gmail.com>

	* src/flashcache_conf.c: Make use of the global variable of type
	dm_kcopyd_client instead of the one which is the member of struct
	cache_c (which has been removed)

2011-08-08  Mohan Srinivasan <mohan@devrs301.snc6.facebook.com>

	* src/flashcache.h, src/flashcache_conf.c, src/flashcache_main.c,
	src/flashcache_subr.c: Changes that move the DM specific
	initialization to the flashcache module init/exit functions. These
	need to be done just once (not once for each cache). This fixes a
	problem where creation of several caches would fail because each
	cache would try and resize the DM memory pools. With this change, we
	should be able to create large numbers of caches (subject to being
	 to allocate flashcache metadata).  This commit also refactors some
	of the code to get flashcache compiling on 3.0.  Thanks to Dr. Arne
	Wiebalck, who originally found the issue with creating several
	caches and developed a fix for it.

2011-08-08  Mohan Srinivasan <mohan@devrs301.snc6.facebook.com>

	* : commit f6f89ed59d0cf209f42675e0ce2f6e7a1e0d9e0f Merge: 417ad43
	8d24994 Author: Mohan Srinivasan <mohan_srinivasan@yahoo.com> Date:
	Mon Aug 8 12:01:11 2011 -0700

2011-08-08  Rohan Puri <rohan.puri15@gmail.com>

	* src/flashcache_conf.c: linux-3.0 compile errors fixed, tested the
	patch with fio

2011-04-18  Florian Haas <florian.haas@linbit.com>

	* src/ocf/flashcache: OCF RA: log a more verbose error message on
	device clash

2011-04-18  Florian Haas <florian.haas@linbit.com>

	* src/ocf/flashcache: OCF RA: be more paranoid checking for existing
	devices

2011-04-18  Florian Haas <florian.haas@linbit.com>

	* src/ocf/flashcache: OCF RA: allow for device major 253 and 254

2011-04-18  Florian Haas <florian.haas@linbit.com>

	* src/ocf/flashcache: OCF RA: make sure flashcache module is loaded

2011-04-15  Florian Haas <florian.haas@linbit.com>

	* src/Makefile, src/ocf/Makefile: OCF RA: add to the build/install
	infrastructure

2011-04-15  Florian Haas <florian.haas@linbit.com>

	* src/ocf/flashcache: Add an OCF-compliant flashcache resource agent

2011-07-22  Mohan Srinivasan <mohan@devrs301.snc6.facebook.com>

	* src/flashcache_main.c: 1) Fix an off by 1 bug in flashcache_lookup(), where a cache hit for
	index 0 was ignored. This is a efficiency/slight performance bug,
	not a correctness/data integrity bug. Even though the cache hit is
	missed, the valid block would be (unnecessarily) invalidated, and
	re-fetched, in the course of the request, ensuring data integrity.
	Thanks to Brian Foster (EMC) for finding and fixing this bug.  2) Eliminate a loop over the entire cache set in flashcache_lookup()
	to look for an invalid block and roll the search for the invalid
	block into the loop where we are looking for a cache hit.

2011-07-19  Mohan Srinivasan <mohan@devrs301.snc6.facebook.com>

	* doc/flashcache-sa-guide.txt, src/Makefile, src/flashcache.h,
	src/flashcache_conf.c, src/flashcache_ioctl.c,
	src/flashcache_main.c, src/flashcache_procfs.c,
	src/flashcache_subr.c, src/utils/Makefile,
	src/utils/flashcache_create.c, src/utils/flashcache_load.c: 1) Integration of all 3 caching modes (writeback, writethrough and
	writearound) into the main flashcache module. Flashcache utilities
	have been modified to add support for this as well.  2) Total Overhaul of the flashcache sysctls. Creates per-cache
	device sysctl sets, so each individual cache device can be tuned
	differently.

2011-06-01  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* flashcache-wt/README, flashcache-wt/src/flashcache_wt.c,
	flashcache-wt/src/flashcache_wt.h,
	flashcache-wt/src/utils/flashcache_wt_create.c: 1) Add "write around" caching mode to flashcache_wt. In this mode
	only reads are cached. All writes result in cache invalidations and
	writes to disk. Suitable for read mostly workloads. Use the new -r
	argument to flashcache_wt_create to choose "write around".  2) Make flashcache block checksums a compile time selection.

2011-04-30  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* flashcache-wt/src/Makefile: Adding missing includes to wt mode
	Makefile.  Contributed by Arne Wiebalck.

2011-04-20  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* flashcache-wt/src/flashcache_wt.c, src/flashcache_main.c: Fixes to
	get flashcache building on >= 2.6.37.  Contributed by TAIRA Hajime.

2011-04-20  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_subr.c: Remove unplug calls. Not
	needed any more at all. This causes flashcache to not build on
	2.6.39.  Caught, tested by Sergey Vidyuk.

2011-04-18  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_conf.c: Fix for a potential integer overflow bug.
	Contributed by Tao Ma.

2011-04-12  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache.mod.c: Remove flashcache.mod.c which accidentally
	got committed and pushed.  Thanks to Tao Ma for pointing that out.

2011-04-06  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache.h, src/flashcache.mod.c, src/flashcache_conf.c,
	src/flashcache_ioctl.c, src/flashcache_ioctl.h,
	src/flashcache_main.c, src/flashcache_subr.c: Update email id in the
	source comments. Emails to my old email id bounce.

2011-04-06  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* doc/flashcache-doc.txt, doc/flashcache-sa-guide.txt: Document the
	idle cleaning support.

2011-03-31  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_conf.c: Fix for a bug in flashcache_init(), where
	the wrong size was being passed into kmalloc() for an allocation.
	Fixed contributed by Tao Ma.

2011-03-23  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_conf.c: Bounds on fallow_clean_speed.

2011-03-22  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_main.c: Fix a race in the pending logic, which
	would cause us to miss processing pending, queued jobs.

2011-03-22  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_conf.c, src/flashcache_main.c: 
	Add a fallow_clean_speed knob. This controls the rate at which
	fallow cleaning is done.

2011-03-22  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_conf.c, src/flashcache_ioctl.c,
	src/flashcache_main.c, src/flashcache_subr.c: Revert the finegrained
	locking changes. There are subtle races that show up under load that
	I still need to debug and fix.

2011-03-16  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_conf.c, src/flashcache_ioctl.c,
	src/flashcache_main.c, src/flashcache_subr.c: Fine grained locking
	of flashcache. Break up the big cache spin lock into smaller locks,
	introducing per-cache set spinlocks.

2011-03-08  Mohan Srinivasan <mohan@devrs010.snc1.facebook.com>

	* src/flashcache_conf.c, src/flashcache_main.c: Change the fallow
	cleaning default (from 1 min to 15 mins) to slow down idle dirty
	block cleaning. And fix something I broke in the previous commit.

2011-03-08  Mohan Srinivasan <mohan@devrs010.snc1.facebook.com>

	* src/flashcache_main.c: Fix a bug in the fallow disk cleaning
	logic. The bug caused hyper aggressive disk cleaning when fallow
	dirty block cleaning was enabled.

2011-03-07  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/utils/flashcache_create.c, src/utils/flashcache_load.c: Added
	checking return value from system(dmsetup_cmd), and exit(1) if
	non-zero, in flashcache_create.c and flashcache_load.c. This helps
	using the utils in scripts.  Contributed by Alexander Nezhinsky
	(Mellanox).

2011-03-01  Mohan Srinivasan <mohan@devrs010.snc1.facebook.com>

	* src/Makefile, src/utils/Makefile: Added independent evaluation of
	COMMIT_REV, overriden from input to be used when make is called from
	src or src/utils.  Contributed by Alexander Nezhinsky.

2011-03-01  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* doc/flashcache-sa-guide.txt, src/flashcache.h,
	src/flashcache_conf.c, src/flashcache_main.c, src/flashcache_subr.c: 
	IO latency histograms added.  Latency histograms are reported via
	'dmsetup status'. This is disabled by default, because latencies are
	computed using gettimeofday, so depending on the clocksource, this
	can be quite expensive. To enable computation and reporting of IO
	latency histogram, enable the flashcache.io_latency_hist sysctl.

2011-03-01  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_conf.c, src/flashcache_ioctl.c,
	src/flashcache_main.c, src/flashcache_subr.c: Move stats and errors
	into their own structs.

2011-03-01  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_conf.c: Clean up formatting of dmsetup status.

2011-02-22  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_conf.c, src/flashcache_main.c: 
	Fix a race in the device (slow) removal path. The race is one where
	a background set cleaning schedules a delayed cleaning. The delayed
	cleaning (from workqueue) happens after the device is completely
	gone, causing a panic. To fix this, when the device is being
	removed, stop all background set cleanings first. Once all blocks
	have been cleaned, cancel any pending delayed work items, and flush
	workqueue to wait for everything to finish.

2011-02-22  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_ioctl.c: Fix a bug where the expiry for an item on
	the whitelist or blacklist isn't initialized correctly. This fix is
	only relevant for cases where expiring nodes from the white/black
	list is enabled (ie. it is only relevant when the do_pid_expiry
	sysctl is enabled).

2011-02-22  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* doc/flashcache-doc.txt, doc/flashcache-sa-guide.txt,
	src/flashcache.h, src/flashcache_conf.c, src/flashcache_main.c,
	src/flashcache_subr.c: Adds a second block cleaning heuristic. Clean
	dirty blocks based on some amount of "inactivity". The default
	policy is to clean dirty blocks that were inactive for the last 60
	seconds. But this can be changed with fallow_delay (seconds).
	Setting fallow_delay to 0 completely turns off the "clean based on
	inactivity" policy.

2011-02-22  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/Makefile: Slight addition to the previous Makefile commit,
	adding -I$(KERNEL_TREE)/include/ to CFLAGS, per Vadim's fix.

2011-02-22  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/Makefile, src/utils/Makefile: Makefile cleanups contributed by
	Alexander Nezhinsky (of Voltaire).  Thanks also to Vadim Tkachenko
	and Or Gerlitz for suggesting the fix of adding
	$(KERNEL_TREE)/include/linux to CFLAGS.

2011-02-16  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* flashcache-wt/src/flashcache_wt.c,
	flashcache-wt/src/flashcache_wt.h: 1) Fix for a critical (and rather embarassing) copy-paste bug in the
	previous commit. The bug only really affects writethrough mode.
	This bug can corrupt filesystems, because it confuses the cache_dev
	and disk_dev.  2) Adding a bunch of stats while at it.

2011-02-13  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* doc/flashcache-sa-guide.txt: Added a "thanks to Earle Philhower"
	comment to the sa-guide for the configurable metadata blocksize
	feature.

2011-02-11  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* doc/flashcache-sa-guide.txt: Document "flashcache_create -m" in
	the SA guide.

2011-02-11  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* doc/flashcache-sa-guide.txt, src/flashcache.h,
	src/flashcache_conf.c, src/flashcache_main.c,
	src/flashcache_subr.c, src/utils/flashcache_create.c,
	src/utils/flashcache_destroy.c: 1) Support for configurable flashcache metadata block sizes. This
	change allows us to configure a 4KB or 8KB (or larger) metadata
	blocksize.  2) The start of the metadata region and data region on the cache
	device is aligned to the metadata blocksize.  3) Adds a -m argument to flashcache_create to optionally configure
	the metadata blocksize. Default is 4KB.  4) Flashcache on-ssd revision bump.  See the flashcache sa-guide for
	more detail.  This change authored by Earle Philhower of Virident
	(earle at virident dot com) with help from Mohan.

2011-01-26  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_subr.c: When syncing dirty blocks from a cache
	removal, flashcache could flood printks (cleaning progress updates).
	This can cause node hangs. Ratelimit these progress update printks
	to avoid this.  Huge thanks to Feng Yu for finding this bug,
	narrowing it down to the printk as the proble and, testing the fix.
	Thanks also to Jens Axboe for spending time on this.

2011-01-23  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_subr.c: Fix the dirty percent calculation in
	update_sync_progress().

2011-01-19  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_conf.c: Replace the one use of float (in the
	dmsetup table path) and replace it with u_int64_t. Usage of float
	(without saving and restoring fp state across the math) is a bug
	because it corrupts userspace fp state.  Thanks to Jens Axboe for
	pointing this bug out.

2011-01-19  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_main.c: Clear the stop_sync state when starting up
	a sync. This fixes a bug there a (slow) dmsetup remove hangs forever
	while cleaning dirty blocks if a stop_sync was ever done.

2011-01-19  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* doc/flashcache-sa-guide.txt: Fix a couple of typos in the optimal
	XFS agsize/agcount computations.  Spotted by Feng Yu.

2011-01-18  Mohan Srinivasan <mohan@opsdev209.snc1.facebook.com>

	* src/flashcache_main.c: Always push the metadata update to the
	worker thread upon completion of the data write. This fixes a
	deadlock caused by an IO completion thread blocking on a write.
	Thanks to Feng Yu for finding, reporting the bug and Jens Axboe for
	the fix.

2011-01-06  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_conf.c: Fix a linux 2.6.18/2.6.19 compile problem
	that crept in when I committed the fix for the Ubuntu/Debian sysctl
	fixes.  Thanks to Feng Yu for reporting and fixing this.

2011-01-05  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_conf.c: If for a bug (in the flashcache_create
	path) I introduced when the dm_get_device wrapper
	(flashcache_get_dev()) was introduced, a few days ago. The size of
	the disk dev was being truncated to fit in a int32.  Thanks to Feng
	Yu for catching the bug and providing a fix.

2011-01-03  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_conf.c, src/utils/flashcache_create.c: 1) Add an option to flashcache_create (-a) to specify cache
	associativity.  2) Fixes for lots of minor bugs in flashcache_create.  Patch
	submitted by Krzysztof Blaszkowski.

2011-01-03  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_subr.c: Add a missing cast to cache block address
	computation.  Patch submitted by Krzysztof Blaszkowski.

2010-12-22  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* Makefile, src/Makefile, src/flashcache_conf.c,
	src/utils/flashcache_create.c, src/utils/flashcache_destroy.c,
	src/utils/flashcache_load.c: Add git rev to /proc/flashcache_version
	and to the usage() printed out by the flashcache utils.  Patch
	contributed by Krzysztof Blaszkowski.

2010-12-22  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/Makefile: Makefile improvement contributed by Krzysztof
	Blaszkowski.

2010-12-22  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_conf.c: A cleanup to flashcache_ctr(), adding a
	inline wrapper funtion around dm_get_device().  Patch contributed by
	Krzysztof Blaszkowski.

2010-12-14  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_conf.c: Fix for the sysctl
	problems on Ubuntu/Debian kernels. With this change, the sysctl
	interface on these platforms works.  Thanks to : Hector Izquierdo
	Seliva for researching, providing, testing the fix.  Michael Iverson
	and Moritz for testing the fix.

2010-12-13  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_main.c: Remove the calls to unplug the ssd's device
	queue after enqueueing an IO to it. This was done a long time ago to
	optimize for a perverse workload, but it breaks almost all common
	workloads by inhibiting request merging. This change reduces ssd
	%util significantly and has other beneficial effects.

2010-12-11  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_conf.c: Fixes a copy-paste bug in the previous
	commit (for the RHEL6 port).  Thanks to Krzysztof Blaszkowski for
	catching this and providing a fix for this.

2010-12-07  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* Makefile, flashcache-wt/Makefile, flashcache-wt/src/Makefile,
	flashcache-wt/src/flashcache_wt.c, src/Makefile,
	src/flashcache_conf.c: Committing changes from Taira Hajime (redhat)
	for getting flashcache compiling on RHEL6 and make intall.

2010-12-01  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_subr.c: Fixes a panic in the flashcache_create/load
	path in some Linux releases (between .22 and .29).

2010-11-29  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* flashcache-wt/src/flashcache_wt.c, src/flashcache_main.c: 2.6.26
	port. Contributed by John M. Drescher.

2010-11-22  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_main.c: Fix error handling in the DM callbacks. we
	maps any error from the block layer to -EIO.

2010-11-09  Mohan Srinivasan <mohan@devrs002.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_conf.c, src/flashcache_main.c,
	src/flashcache_subr.c: 1) evert a change to the read cache path. The change being revertedd
	is found to hang IOs (reads) on 2.6.18 (originally tested on later
	kernels where the hang was not seen).  The change being reverted : commit 9f9914ae1dc8e313ba42fa2a60f913eb8d8cd10b Date:   Tue Aug 17
	13:32:45 2010 -0700     Changes to the cache miss (readfill) path to send out longer
	    (sorted) chains of writes to the ssd.  2) Add a log message for disk errors in the uncached IO path.

2010-10-25  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_conf.c, src/flashcache_ioctl.c: flashcache 2.6.34
	port.  Submitted by Taira Hajime and Patrick Mullaney.

2010-10-21  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_conf.c, src/flashcache_main.c: 1) Fix for a bug where an IO error would not be passed up for
	uncached IOs.  2) Add a counter for a specific case in the uncached IO path.

2010-10-15  Mohan Srinivasan <mohan@devrs002.snc1.facebook.com>

	* flashcache-wt/src/flashcache_wt.c,
	flashcache-wt/src/flashcache_wt.h, src/flashcache.h,
	src/flashcache_conf.c, src/flashcache_ioctl.c,
	src/flashcache_main.c, src/flashcache_subr.c: Fixes for build errors
	on releases 2.6.21-2.6.27.  Flashcache and Flashcache-wt build
	successfully on every release from 2.6.18..2.6.33 now.

2010-10-13  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_ioctl.c: Fix a build error around
	find_task_by_vpid().

2010-10-04  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* flashcache-wt/src/flashcache_wt.c: flashcache-wt ported to 2.6.34.
	Patch submitted by Hajime Taira (Redhat).  htaira at redhat dot com

2010-10-04  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_conf.c: ifdef out 2 sysctls that are only really
	useful in devel builds.

2010-10-04  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache_ioctl.c: Fix a compile warning in the previous
	commit.

2010-10-04  ps <ps@facebook.com>

	* src/flashcache.h, src/flashcache_conf.c, src/flashcache_ioctl.c: 
	Allow flashcache to work on 2.6.33.

2010-08-27  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* : commit bb0caaad00510cea727459c74d763c350abf1d08 Merge: 1294fa3
	c7ee0f4 Author: Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>
	Date:   Fri Aug 27 15:19:53 2010 -0700

2010-08-27  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* : commit 1294fa3521687874c3a31a20b7032e1c0c500a00 Author: Mohan
	Srinivasan <mohan@devrs001.snc1.facebook.com> Date:   Fri Aug 27
	10:51:02 2010 -0700

2010-08-27  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_conf.c, src/flashcache_main.c,
	src/flashcache_subr.c: Changes to cut down the memory footprint of
	flashcache by 1/3 by cutting down the per-block in-memory metadata
	by 1/3. This results in big savings. For a 600GB cache this cuts
	down the memory footprint by 1.2GB, for a 300GB cache, the savings
	is 600GB.

2010-08-27  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* flashcache-wt/src/flashcache_wt.c, src/flashcache_subr.c: Replace
	kmap() with kmap_atomic in the block checksum path, since kmap can
	block and checksum computes can be done from softirq. This fixes a
	panic where kmap() blocks when checksum validation is done from
	softirq.  Thanks to Dushy for reporting this and for verifying the fix !

2010-08-25  Mohan Srinivasan <mohan@opsdev209.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_conf.c, src/flashcache_main.c,
	src/flashcache_subr.c: Changes to improve batching of ssd metadata
	updates.

2010-08-18  Mohan Srinivasan <mohan@opsdev209.snc1.facebook.com>

	* doc/flashcache-sa-guide.txt: Add a section on tuning XFS for
	flashcache.

2010-08-17  Mohan Srinivasan <mohan@opsdev209.snc1.facebook.com>

	* src/Makefile, src/flashcache.h, src/flashcache_conf.c,
	src/flashcache_ioctl.c, src/flashcache_ioctl.h,
	src/flashcache_main.c: Move the ioctl code to a different file
	(flashcache_ioctl.c).

2010-08-17  Mohan Srinivasan <mohan@opsdev209.snc1.facebook.com>

	* src/flashcache_subr.c: Replace a superflous if() in the
	write_merge code with an assertion.

2010-08-17  Mohan Srinivasan <mohan@opsdev209.snc1.facebook.com>

	* src/flashcache_main.c: Fix up some comments and whitespace.

2010-08-17  Mohan Srinivasan <mohan@opsdev209.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_conf.c, src/flashcache_main.c,
	src/flashcache_subr.c: Changes to the cache miss (readfill) path to
	send out longer (sorted) chains of writes to the ssd.

2010-08-17  Mohan Srinivasan <mohan@opsdev209.snc1.facebook.com>

	* src/flashcache_conf.c: Fix an overflow bug in the computation of
	cache percent and dirty percent.

2010-08-17  Mohan Srinivasan <mohan@opsdev209.snc1.facebook.com>

	* src/flashcache.h: Remove an unnecessary (and potentially
	confusing) #define.

2010-08-06  Mohan Srinivasan <mohan@opsdev209.snc1.facebook.com>

	* src/flashcache_main.c: Refactor flashcache_read/flashcache_write,
	moving some code into functions for better readability.

2010-08-03  Mohan Srinivasan <mohan@opsdev209.snc1.facebook.com>

	* flashcache-wt/src/flashcache_wt.c, src/flashcache_conf.c,
	src/flashcache_main.c: Add a flashcache release number, exported by
	/proc/flashcache_version (and /proc/flashcache_wt_version).

2010-08-02  Mohan Srinivasan <mohan@opsdev209.snc1.facebook.com>

	* flashcache-wt/src/flashcache_wt.c: (Ported forth from the
	writeback version).  Fix for a data corruption that can occur with non co-ordinated IOs
	for a block. The requirement for this bug to occur is for concurrent
	Writes and Reads *of the same block* to be sent down. Not likely to
	occur in production if we go through the pagecache (or with InnoDB
	doing O_DIRECT), because buffers undergoing IO will be locked.  The bug occurs because concurrent IOs (at least one of which must be
	a Write, and at least one which which must be uncached in
	flashcache), can get re-ordered. The fix is to handle uncached IOs
	totally within flashcache and invalidate overlapping blocks on the
	completion of an uncached IO.  Although this bug is unlikely to occur in production, it is a good
	idea to upgrade.  Thanks to Paul Saab for finding this bug.

2010-08-02  Mohan Srinivasan <mohan@opsdev209.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_main.c, src/flashcache_subr.c: 
	Fix for a data corruption that can occur with non co-ordinated IOs
	for a block. The requirement for this bug to occur is for concurrent
	Writes and Reads *of the same block* to be sent down. Not likely to
	occur in production if we go through the pagecache (or with InnoDB
	doing O_DIRECT), because buffers undergoing IO will be locked.  The bug occurs because concurrent IOs (at least one of which must be
	a Write, and at least one which which must be uncached in
	flashcache), can get re-ordered. The fix is to handle uncached IOs
	totally within flashcache and invalidate overlapping blocks on the
	completion of an uncached IO.  Although this bug is unlikely to occur in production, it is a good
	idea to upgrade. (The fastest way to upgrade is to do a "fast"
	shutdown, followed by a reload of the module and device load).  Thanks to Paul Saab for finding this bug.

2010-07-21  Mohan Srinivasan <mohan@devrs003.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_conf.c, src/flashcache_main.c: 
	Add some more stats. Add one more /proc node for exporting io size
	histograms via /proc. Part of the effort to get the open source repo
	in sync with the internal facebook repo.

2010-07-21  Mohan Srinivasan <mohan@devrs003.snc1.facebook.com>

	* doc/flashcache-doc.txt, doc/flashcache-sa-guide.txt,
	src/flashcache.h, src/flashcache_conf.c, src/flashcache_ioctl.h,
	src/flashcache_main.c: Completely re-designed cache controls. The
	new design is documented in the SA Guide.

2010-07-20  Mohan Srinivasan <mohan@devrs003.snc1.facebook.com>

	* src/flashcache_main.c: Refactor some code, introducing a new
	function and moving code into it.

2010-07-20  Mohan Srinivasan <mohan@devrs003.snc1.facebook.com>

	* src/flashcache_main.c: Remove a unnecessary check in the dirty
	block cleaning path for the LRU reclaim policy.

2010-07-20  Mohan Srinivasan <mohan@devrs003.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_conf.c: At flashcache
	load/create/remove, do larger metadata IOs (256KB IOs instead of 1
	sector). This speeds up load, create and (fast) removal
	significantly by factors of 19x, 12x and 8x respectively. Bring them
	down to <= 10s for a 152GB cache (Intel SSD).

2010-07-19  Mohan Srinivasan <mohan@devrs003.snc1.facebook.com>

	* src/flashcache.h: Make the default flashcache blocksize 4KB.

2010-07-19  Mohan Srinivasan <mohan@devrs003.snc1.facebook.com>

	* src/flashcache_main.c: When stop_sync is set, don't stop any
	dirty-threshold driven cleanings.  Only stop explicit syncs.

2010-07-19  Mohan Srinivasan <mohan@devrs003.snc1.facebook.com>

	* src/flashcache.h, src/flashcache_conf.c: On a dmsetup remove, loop
	around the sync until all dirty blocks are cleaned. dmsetup table
	dumps out the ssd and disk dev names.

2010-06-09  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* doc/flashcache-sa-guide.txt: Remove references to using a 16KB
	blocksize. And document that the 4KB blocksize is the right choice.

2010-06-01  Graeme Humphries <graeme@demonware.net>

	* : commit bc4cc7987b279490d00006fe99fa7ace0758561a Author: Mohan
	Srinivasan <mohan@devrs001.snc1.facebook.com> Date:   Tue Jun 1
	14:47:19 2010 -0700

2010-06-01  Graeme Humphries <graeme@demonware.net>

	* : commit 98f8182aef7439513428fa35503c1bdb7ed719c7 Author: Mohan
	Srinivasan <mohan@devrs001.snc1.facebook.com> Date:   Tue Jun 1
	12:20:37 2010 -0700

2010-05-31  Graeme Humphries <graeme@demonware.net>

	* README-DKMS: Need to explicitly run "dkms build" before "dkms
	install".

2010-05-31  Graeme Humphries <graeme@demonware.net>

	* flashcache-wt/src/dkms.conf, src/dkms.conf: Put in "0.1" as
	version numbers in configs and docs, in lieu of upstream version
	numbers.

2010-05-31  Graeme Humphries <graeme@demonware.net>

	* README-DKMS, flashcache-wt/src/dkms.conf, src/dkms.conf: Removed
	extraneous post-build hooks from dkms.confs, made info about utils
	more explicit in README-DKMS.

2010-05-31  Graeme Humphries <graeme@demonware.net>

	* README-DKMS: Added a quick little howto on using dkms to build /
	install flashcache.

2010-05-31  Graeme Humphries <graeme@demonware.net>

	* flashcache-wt/src/dkms.conf, src/dkms.conf: Created dkms configs
	for easier building and tracking on platforms that support dkms.

2010-05-28  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* flashcache-wt/README, flashcache-wt/src/flashcache_wt.c,
	flashcache-wt/src/flashcache_wt.h: Port flashcache_wt to later Linux
	releases (2.6.27 - 2.6.32).  Eliminate compile warnings.

2010-05-27  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* flashcache-wt/src/flashcache_wt.c: Fix outdated comments and very
	minor cleanups.

2010-05-27  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* README, doc/flashcache-sa-guide.txt, flashcache-wt/Makefile,
	flashcache-wt/README, flashcache-wt/src/Makefile,
	flashcache-wt/src/flashcache_wt.c,
	flashcache-wt/src/flashcache_wt.h,
	flashcache-wt/src/utils/flashcache_wt_create.c: Commit a "write
	through" variant of flashcache. Changes to the top level README to
	document that and a change to the flashcache sa-guide.

2010-05-26  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* README-CentOS5.4: Add instructions on building Flashcache for
	CentOS5.4.  Author : Vadim Tkachenko of Percona.

2010-05-26  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* src/flashcache.h, src/utils/flashcache_destroy.c: Add checks to
	flashcache_destroy for DIRTY blocks. Abort a destroy if dirty blocks
	are present in the cache. Add a -f option to flascache_destroy to
	proceed destroying the cache even if dirty blocks are present.

2010-05-20  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* README, src/flashcache.h, src/flashcache_conf.c,
	src/flashcache_main.c, src/flashcache_subr.c: Flashcache port to
	newer Linux releases (2.6.20-2.6.32).  Port done by Vadim Tkachenko
	(Percona) with help from Mohan.

2010-05-19  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* doc/flashcache-sa-guide.txt, src/flashcache.h,
	src/flashcache_conf.c, src/flashcache_main.c: Fix a bug in the sync
	path, where a do_sync sometimes wouldn't reliably sync all dirty
	blocks to disk. Add a "stop_sync" sysctl that stops a sync that is
	in progress.

2010-05-19  Mohan Srinivasan <mohan@devrs001.snc1.facebook.com>

	* doc/flashcache-sa-guide.txt: Document flashcache_create -f

2010-04-21  ps <ps@facebook.com>

	* Initial import of flashcache.  A write back block cache Linux kernel
	module.

